# ipblc

[![Build Status](https://drone.paulbsd.com/api/badges/paulbsd/ipblc/status.svg)](https://drone.paulbsd.com/paulbsd/ipblc)

## Summary

ipblc is a tool that search and send attacking ip addresses to ipbl
It's notification features are based on zeromq

## Howto

### Build

- Dev:

```bash
cargo build
```

- Release (with compiler optimizations)

```bash
cargo build --release
```

### Usage

```
USAGE:
    ipblc [OPTIONS]

OPTIONS:
    -d                           Enable debugging
    -h, --help                   Print help information
    -s, --server <server>        Sets a ipbl server [default: https://ipbl.paulbsd.com]
    -V, --version                Print version informatio
```

### TODO

- ✅ Config centralization (Main config in ipbl)
- ✅ Handles date in log
- ✅ Fine grain file opening
- ✅ Handle zeromq data transfer
- ✅ Code optimizations (WIP)
- ✅ Error handing when fetching config

### Date formats

```
nginx:    2006-01-02T15:04:05+01:00
ssh:      2006-01-02T15:04:05.000000+01:00
openvpn:  2006-01-02 15:04:05
mail:     2006-01-02T15:04:05.000000+01:00
```

## License

```text
Copyright (c) 2021, 2022 PaulBSD
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of this project.
```
